'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.googleApis = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _es6Promisify = require('es6-promisify');

var _es6Promisify2 = _interopRequireDefault(_es6Promisify);

var _googleapis = require('googleapis');

var _googleapis2 = _interopRequireDefault(_googleapis);

var _parseDuration = require('parse-duration');

var _parseDuration2 = _interopRequireDefault(_parseDuration);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * MIT License
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Copyright (c) 2017 Choko (choko@curioswitch.org)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * Permission is hereby granted, free of charge, to any person obtaining a copy
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * of this software and associated documentation files (the "Software"), to deal
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * in the Software without restriction, including without limitation the rights
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * copies of the Software, and to permit persons to whom the Software is
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * furnished to do so, subject to the following conditions:
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * The above copyright notice and this permission notice shall be included in all
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * copies or substantial portions of the Software.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            * SOFTWARE.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                            */

class GoogleApis {
  constructor() {
    this.projectId = null;
    this.cancelBuild = null;
    this.createBuild = null;
    this.listBuilds = null;
    this.decryptKms = null;
  }

  decryptKey(location, keyring, key, encryptedBase64) {
    var _this = this;

    return _asyncToGenerator(function* () {
      yield _this.init();

      if (!_this.projectId) {
        throw new Error('Not initialized.');
      }

      const request = {
        name: `projects/${_this.projectId}/locations/${location}/keyRings/${keyring}/cryptoKeys/${key}`,
        resource: {
          ciphertext: encryptedBase64
        }
      };

      if (!_this.decryptKms) {
        throw new Error('Not initialized.');
      }
      const { plaintext } = yield _this.decryptKms(request);
      return plaintext;
    })();
  }

  cancelCloudbuild(id) {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      yield _this2.init();

      if (!_this2.projectId) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const request = {
        projectId: _this2.projectId,
        id
      };
      if (!_this2.cancelBuild) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      return _this2.cancelBuild(request);
    })();
  }

  listCloudbuilds(filter) {
    var _this3 = this;

    return _asyncToGenerator(function* () {
      yield _this3.init();

      if (!_this3.projectId) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const request = {
        projectId: _this3.projectId,
        filter
      };
      if (!_this3.listBuilds) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const { builds } = yield _this3.listBuilds(request);
      return builds || [];
    })();
  }

  startCloudbuild(cloudbuildConfig, substitutions, tags) {
    var _this4 = this;

    return _asyncToGenerator(function* () {
      yield _this4.init();

      if (!_this4.projectId) {
        throw new Error('Not initialized, this is a programming bug.');
      }

      const sanitizedConfig = cloudbuildConfig.timeout ? _extends({}, cloudbuildConfig, {
        timeout: `${(0, _parseDuration2.default)(cloudbuildConfig.timeout) / 1000}s`
      }) : cloudbuildConfig;
      const request = {
        projectId: _this4.projectId,
        resource: _extends({}, sanitizedConfig, {
          options: {
            substitutionOption: 'ALLOW_LOOSE'
          },
          substitutions,
          tags
        })
      };

      console.log('Creating build job.');
      if (!_this4.createBuild) {
        throw new Error('Not initialized, this is a programming bug.');
      }
      const response = yield _this4.createBuild(request);
      console.log(response);
      return response;
    })();
  }

  init() {
    var _this5 = this;

    return _asyncToGenerator(function* () {
      if (_this5.projectId) {
        return;
      }

      const { auth, projectId } = yield _this5.authorize();
      _this5.projectId = projectId;
      const cloudkms = _googleapis2.default.cloudkms({ version: 'v1', auth });
      _this5.decryptKms = (0, _es6Promisify2.default)(cloudkms.projects.locations.keyRings.cryptoKeys.decrypt, cloudkms);

      const cloudbuild = _googleapis2.default.cloudbuild({ version: 'v1', auth });
      _this5.cancelBuild = (0, _es6Promisify2.default)(cloudbuild.projects.builds.cancel, cloudbuild);
      _this5.createBuild = (0, _es6Promisify2.default)(cloudbuild.projects.builds.create, cloudbuild);
      _this5.listBuilds = (0, _es6Promisify2.default)(cloudbuild.projects.builds.list, cloudbuild);
    })();
  }

  authorize() {
    return _asyncToGenerator(function* () {
      return new Promise(function (resolve, reject) {
        return _googleapis2.default.auth.getApplicationDefault(function (err, authClient, projectId) {
          if (err) {
            reject(err);
            return;
          }
          resolve({
            auth: authClient,
            projectId
          });
        });
      });
    })();
  }
}

const googleApis = exports.googleApis = new GoogleApis();